"use strict";

var _require = require('datocms-client'),
    camelize = _require.camelize;

module.exports = function (_ref) {
  var field = _ref.field;
  var fieldKey = camelize(field.apiKey);
  return {
    type: 'String',
    nodeType: 'DatoCmsTextNode',
    resolveForSimpleField: function resolveForSimpleField(fieldValue) {
      return fieldValue;
    },
    resolveForNodeField: function resolveForNodeField(_fieldValue, context, node, i18n) {
      if (field.localized) {
        var candidateLocales = [node.locale, i18n.locale].concat(i18n.fallbacks[i18n.locale] || []).filter(function (x) {
          return !!x;
        });
        var localeWithMatchingNode = candidateLocales.find(function (locale) {
          return context.nodeModel.getNodeById({
            id: ['DatoCmsTextNode', node.entityPayload.id, locale, fieldKey].join('-')
          });
        });
        return context.nodeModel.getNodeById({
          id: ['DatoCmsTextNode', node.entityPayload.id, localeWithMatchingNode, fieldKey].join('-')
        });
      } else {
        return context.nodeModel.getNodeById({
          id: ['DatoCmsTextNode', node.entityPayload.id, fieldKey].join('-')
        });
      }
    }
  };
};